--#
--# Copyright (C)2002..2020 @BABOLO http://www.babolo.ru/
--# PKG = babolo_pglib
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: babolo_pglib--2.00.sql.m4,v 1.14 2020/03/23 18:36:06 babolo Exp $

CREATE OR REPLACE FUNCTION anyequ(anyelement, anyelement) RETURNS bool
 AS 'SELECT $1 IS NOT DISTINCT FROM $2'
 LANGUAGE SQL IMMUTABLE PARALLEL SAFE
;
CREATE OR REPLACE FUNCTION anyneq(anyelement, anyelement) RETURNS bool
 AS 'SELECT $1 IS DISTINCT FROM $2'
 LANGUAGE SQL IMMUTABLE PARALLEL SAFE
;
CREATE OPERATOR ==*
     ( LEFTARG    = anyelement
     , RIGHTARG   = anyelement
     , PROCEDURE  = anyequ
     , COMMUTATOR = ==*
     , NEGATOR    = !=*
     , RESTRICT   = eqsel
     , JOIN       = eqjoinsel
     , HASHES
     , MERGES
     )
;
CREATE OPERATOR !=*
     ( LEFTARG    = anyelement
     , RIGHTARG   = anyelement
     , PROCEDURE  = anyneq
     , COMMUTATOR = !=*
     , NEGATOR    = ==*
     , RESTRICT   = neqsel
     , JOIN       = neqjoinsel
     , HASHES
     , MERGES
     )
;
-- CREATE OPERATOR CLASS anyelement_oops FOR TYPE anyelement USING btree
--  AS OPERATOR 1 <
--   , OPERATOR 2 <=
--   , OPERATOR 3 ==*
--   , OPERATOR 4 >=
--   , OPERATOR 5 >
--   , FUNCTION 1 anyequ(anyelement, anyelement)
-- ;
--########################################################################
--#  pglib_ip
--########################################################################

CREATE OR REPLACE FUNCTION inet(int4) RETURNS inet
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'int4_inet'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION inet(int4)        IS ' int4  IP ';

CREATE OR REPLACE FUNCTION inet(int8) RETURNS inet
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'int8_inet'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION inet(int8)        IS ' int8  IP ';

CREATE OR REPLACE FUNCTION int4(inet) RETURNS int4
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'inet_int4'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION int4(inet)        IS ' IP   int4';

CREATE OR REPLACE FUNCTION int8(inet) RETURNS int8
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'inet_int8'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION int8(inet)        IS ' IP   int8';

CREATE OR REPLACE FUNCTION ip_set(inet, int) RETURNS SETOF inet
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'ip_set'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION ip_set(inet, int) IS '       ';

CREATE OR REPLACE FUNCTION ip_set(inet) RETURNS SETOF inet
 AS 'SELECT ip_set($1, 32)'
 LANGUAGE SQL IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION ip_set(inet)      IS '    ';

CREATE OR REPLACE FUNCTION ip_supernet(inet) RETURNS SETOF inet
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'ip_supernet'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION ip_supernet(inet) IS '    ';

--#
CREATE OR REPLACE FUNCTION ipaggr_in(cstring) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'ipaggr_in'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION ipaggr_in(cstring)        IS '   IP ';

CREATE OR REPLACE FUNCTION ipaggr_out(ipaggr) RETURNS cstring
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'ipaggr_out'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION ipaggr_out(ipaggr)        IS ' IP   ';

CREATE OR REPLACE FUNCTION add_net(ipaggr, inet) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'add_net'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION add_net(ipaggr, inet)     IS '  IP  ';

CREATE OR REPLACE FUNCTION sub_net(ipaggr, inet) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'sub_net'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION sub_net(ipaggr, inet)     IS '  IP  ';

CREATE OR REPLACE FUNCTION add_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'add_ipaggr'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION add_ipaggr(ipaggr, ipaggr)IS '  IP ';

CREATE OR REPLACE FUNCTION sub_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'sub_ipaggr'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION sub_ipaggr(ipaggr, ipaggr)IS '  IP ';

CREATE OR REPLACE FUNCTION inter_ipaggr(ipaggr, ipaggr) RETURNS ipaggr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'inter_ipaggr'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;

CREATE OR REPLACE FUNCTION show_net(ipaggr) RETURNS SETOF cidr
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'show_net'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION show_net(ipaggr)          IS ' IP    ';

CREATE OR REPLACE FUNCTION check_net(ipaggr, inet) RETURNS boolean
 AS 'MODULE_PATHNAME/pglib_ip.so.VMAJOR', 'check_net'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
CREATE TYPE ipaggr
     ( INTERNALLENGTH = VARIABLE
     , INPUT          = ipaggr_in
     , OUTPUT         = ipaggr_out
     , ALIGNMENT      = double
     , STORAGE        = external
     )
;
CREATE AGGREGATE sum_net
     ( SFUNC    = add_net
     , BASETYPE = inet
     , STYPE    = ipaggr
     , INITCOND = 'f'
     )
;
COMMENT ON AGGREGATE sum_net(inet)            IS '   IP ';

CREATE OPERATOR +
     ( LEFTARG    = ipaggr
     , RIGHTARG   = ipaggr
     , PROCEDURE  = add_ipaggr
     , COMMUTATOR = +
);
CREATE OPERATOR -
     ( LEFTARG    = ipaggr
     , RIGHTARG   = ipaggr
     , PROCEDURE  = sub_ipaggr
     , COMMUTATOR = -
     )
;
CREATE OPERATOR *
     ( LEFTARG    = ipaggr
     , RIGHTARG   = ipaggr
     , PROCEDURE  = inter_ipaggr
     , COMMUTATOR = *
     )
;
CREATE OPERATOR +
     ( LEFTARG    = ipaggr
     , RIGHTARG   = inet
     , PROCEDURE  = add_net
     , COMMUTATOR = +
     )
;
CREATE OPERATOR -
     ( LEFTARG    = ipaggr
     , RIGHTARG   = inet
     , PROCEDURE  = sub_net
     , COMMUTATOR = -
     )
;
--########################################################################
--#  pglib_text
--########################################################################

CREATE OR REPLACE FUNCTION quote_html(text) RETURNS text
 AS 'MODULE_PATHNAME/pglib_text.so.VMAJOR', 'quote_html'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
CREATE OR REPLACE FUNCTION quote_sh(text) RETURNS text
 AS 'MODULE_PATHNAME/pglib_text.so.VMAJOR', 'quote_sh'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
CREATE OR REPLACE FUNCTION quote_copy(text) RETURNS text
 AS 'MODULE_PATHNAME/pglib_text.so.VMAJOR', 'quote_copy'
 LANGUAGE C IMMUTABLE PARALLEL SAFE
;

CREATE OR REPLACE FUNCTION compare(integer, text[], text[]) RETURNS bool
 AS 'SELECT CASE WHEN $1 IS NULL
                 THEN FALSE
                 WHEN $2 IS NULL AND $3 IS NULL
                 THEN TRUE
                 WHEN $2 IS NULL OR $3 IS NULL
                 THEN FALSE
                 WHEN array_lower($2, 1) <> array_lower($3, 1)
                   OR (   array_upper($2, 1) <> array_upper($3, 1)
                      AND (array_upper($2, 1) < $1 OR array_upper($3, 1) < $1)
                      )
                 THEN FALSE
                 WHEN array_lower($2, 1) > $1
                 THEN TRUE
                 WHEN array_upper($2, 1) > $1
                 THEN $2[array_lower($2, 1):$1] = $3[array_lower($3, 1):$1]
                 ELSE $2 = $3
            END
    '
 LANGUAGE SQL IMMUTABLE PARALLEL SAFE
;
COMMENT ON FUNCTION compare(integer, text[], text[])
 IS '  $1   $2  $3'
;
--########################################################################
--#  pglib_bytea
--########################################################################

CREATE OR REPLACE FUNCTION bytea(int4, int4) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'int4_bytea'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytea(int4, int4)
 IS '      ,   '
;
CREATE OR REPLACE FUNCTION bytea(int4) RETURNS bytea
 AS 'SELECT bytea($1, 4)'
 LANGUAGE SQL IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytea(int4)       IS '    bytea';

CREATE OR REPLACE FUNCTION bytea(int8, int4) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'int8_bytea'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytea(int8, int4)
 IS '      ,   '
;
CREATE OR REPLACE FUNCTION bytea(int8) RETURNS bytea
 AS 'SELECT bytea($1, 8)'
 LANGUAGE SQL IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytea(int8)       IS '    bytea';

CREATE OR REPLACE FUNCTION int8(bytea) RETURNS int8
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytea_int8'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION int8(bytea) IS '     int8';

CREATE OR REPLACE FUNCTION bytea(text) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'text_bytea'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytea(text)       IS '    bytea';

CREATE OR REPLACE FUNCTION text(bytea) RETURNS text
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytea_text'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION text(bytea)       IS '    text';

CREATE OR REPLACE FUNCTION bytearradd(bytea, bytea) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytearradd'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytearradd(bytea, bytea)
 IS '      <= 255'
;
CREATE OR REPLACE FUNCTION bytearrmax(bytea) RETURNS int4
 AS 'MODULE_PATHNAME/pglib_bytea.so.VMAJOR', 'bytearrmax'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bytearrmax(bytea) IS '     ';

CREATE OR REPLACE FUNCTION bytearrmask(bytea, bit) RETURNS bytea
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'bytearrmask'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bytearrmask(bytea, bit) IS '      ';

CREATE AGGREGATE bytearrsum
     (bytea)
     ( SFUNC       = bytearradd
     , STYPE       = bytea
     , SSPACE      = 12
     , INITCOND    = ''
     , COMBINEFUNC = bytearradd
     , PARALLEL    = SAFE
     )
;
COMMENT ON AGGREGATE bytearrsum(bytea) IS '    <= 255';

--########################################################################
--#  pglib_bit
--########################################################################

--#          --
--#-------------------------------------------------------------
CREATE OR REPLACE FUNCTION num2bit(integer) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'num2bit'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION num2bit(integer)
 IS ' varbit      ,       '
;
CREATE OR REPLACE FUNCTION bit2num(varbit) RETURNS SETOF int4
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'bit2num'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bit2num(varbit)
 IS '   ,        ,       '
;

--#    --
--#----------------------------
CREATE OR REPLACE FUNCTION bitex0(bit, int4) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'bitex0'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bitex0(bit, int4) IS '   ,    0';

CREATE OR REPLACE FUNCTION bitex1(bit, int4) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'bitex1'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION bitex1(bit, int4) IS '   ,    1';

--#  varbit  bool  AND  OR --
--#-------------------------------------
CREATE OR REPLACE FUNCTION boolor(bit) RETURNS bool
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'boolor'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION boolor(bit)       IS 'OR    ';

CREATE OR REPLACE FUNCTION booland(bit) RETURNS bool
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'booland'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION booland(bit)      IS 'AND    ';

--#    , ,            --
--#    ,    --
--#----------------------------------------------------------------------
CREATE OR REPLACE FUNCTION varbiteq(bit, bit) RETURNS bool
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbiteq'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbiteq(bit, bit)   IS '    ';

CREATE OR REPLACE FUNCTION varbitand(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitand'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbitand(bit, bit)  IS 'AND      ';

CREATE OR REPLACE FUNCTION varbitor(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitor'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbitor(bit, bit)   IS 'OR      ';

CREATE OR REPLACE FUNCTION varbitxor(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitxor'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbitxor(bit, bit)  IS 'XOR      ';

CREATE OR REPLACE FUNCTION varbitrst(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitrst'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbitrst(bit, bit)  IS '$1 AND ~$2,       ';

CREATE OR REPLACE FUNCTION varbitmeq(bit, bit, bit) RETURNS bool
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitmeq'
 LANGUAGE C IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbitmeq(bit, bit, bit)  IS '$1  $2    $3';

CREATE OPERATOR ==
     ( LEFTARG    = bit
     , RIGHTARG   = bit
     , PROCEDURE  = varbiteq
     , COMMUTATOR = ==
     )
;
COMMENT ON OPERATOR == (bit, bit)        IS '    ';

CREATE OPERATOR /|
     ( LEFTARG    = bit
     , RIGHTARG   = bit
     , PROCEDURE  = varbitand
     , COMMUTATOR = /|
     )
;
COMMENT ON OPERATOR /| (bit, bit)        IS 'AND      ';

CREATE OPERATOR |/
     ( LEFTARG    = bit
     , RIGHTARG   = bit
     , PROCEDURE  = varbitor
     , COMMUTATOR = |/
     )
;
COMMENT ON OPERATOR |/ (bit, bit)        IS 'OR      ';

CREATE OPERATOR /|/
     ( LEFTARG    = bit
     , RIGHTARG   = bit
     , PROCEDURE  = varbitxor
     , COMMUTATOR = /|/
     )
;
COMMENT ON OPERATOR /|/ (bit, bit)       IS 'XOR      ';

CREATE OPERATOR !
     ( LEFTARG   = bit
     , RIGHTARG  = bit
     , PROCEDURE = varbitrst
     )
;
COMMENT ON OPERATOR ! (bit, bit)         IS '$1 AND ~$2,       ';

--# / varbit --
--#---------------------
CREATE OR REPLACE FUNCTION varbit(text) RETURNS varbit
 AS 'DECLARE
        i int;
        r varbit;
        c char;
     BEGIN
        r := ''''::varbit;
        FOR i IN 1..length($1) LOOP
           c := substr($1, i, 1);
           IF c = ''1''
           THEN r := varbitor(r, bitex0(''1''::varbit, i) >> (i - 1));
           ELSIF c <> ''0''
           THEN RAISE EXCEPTION ''"%" is not a valid binary digit'', c;
           END IF;
        END LOOP;
        RETURN r;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbit(text) IS '   varbit';

CREATE OR REPLACE FUNCTION text(varbit) RETURNS text 
 AS 'DECLARE
        i int;
        t text;
     BEGIN
        t := ''''::text;
        FOR i IN 1..bit_length($1) LOOP
           IF boolor(varbitand($1, (bitex0(''1''::varbit, i) >> (i - 1))))
           THEN t := t || ''1'';
           ELSE t := t || ''0'';
           END IF;
        END LOOP;
        RETURN t;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT PARALLEL SAFE
;
COMMENT ON FUNCTION varbit(text) IS ' varbit  ';

--#  bool --
--#-------------------

CREATE AGGREGATE bit_xor(int)
     ( SFUNC = int4xor
     , STYPE = int
     )
;
COMMENT ON AGGREGATE bit_xor(int) IS 'bitwise-xor int4 aggregate';

CREATE AGGREGATE bit_xor(int8)
     ( SFUNC = int8xor
     , STYPE = int8
     )
;
COMMENT ON AGGREGATE bit_xor(int8) IS 'bitwise-xor int8 aggregate';

--#  varbit  AND  OR --
--#---------------------------------
CREATE OR REPLACE FUNCTION varbitandn(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitand'
 LANGUAGE C IMMUTABLE PARALLEL SAFE
;
COMMENT ON FUNCTION varbitandn(bit, bit) IS 'varbitand  ';

CREATE OR REPLACE FUNCTION varbitorn(bit, bit) RETURNS varbit
 AS 'MODULE_PATHNAME/pglib_bit.so.VMAJOR', 'varbitor'
 LANGUAGE C IMMUTABLE PARALLEL SAFE
;
COMMENT ON FUNCTION varbitorn(bit, bit)  IS 'varbitor  ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bit
     , SFUNC    = varbitandn
     , STYPE    = varbit
     )
;
COMMENT ON AGGREGATE conjunction(bit)    IS ' AND  bit';

CREATE AGGREGATE disjunction
     ( BASETYPE = bit
     , SFUNC    = varbitorn
     , STYPE    = varbit
     )
;
COMMENT ON AGGREGATE disjunction(bit)    IS ' OR  bit';
